RecountFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0"); 
local L = AceLibrary("AceLocale-2.2"):new("RecountFu"); 
local Tablet = AceLibrary("Tablet-2.0");

L:RegisterTranslations("enUS", function() return { 
   ["tabletHint1"] = "Left-Click to toggle window visibility.", 
   ["tabletHint2"] = "Double-Left-Click to reset window position.",  
   ["tabletHint3"] = "Alt-Click to reset data.",  
   ["labelName"] = "Recount",
   ["recountFuMenuTitle"] = "Recount Options",
   ["menuOptionChooseViewTitle"] = "Choose View Mode",
   ["menuOptionChooseViewDesc"] = "Select which report to view in the Recount Window",
} end); 

L:RegisterTranslations("deDE", function() return { 
    ["tabletHint1"] = "Linksklick um das Recount-Fenster ein-/auszublenden.", 
    ["tabletHint2"] = "Doppel-Linksklick um die Fensterposition zur\195\188ckzusetzen.",      
    ["tabletHint3"] = "Alt-Click um Daten zu resetten.",  
    ["labelName"] = "Recount",
    ["recountFuMenuTitle"] = "Recount Optionen",
    ["menuOptionChooseViewTitle"] = "Ansichtsmodus w\195\164hlen",
    ["menuOptionChooseViewDesc"] = "Ausw\195\164hlen welcher Report im Recount-Fenster angezeigt werden soll.",
} end);







RecountFu.hasIcon = true; 
RecountFu.defaultPosition = "RIGHT"; 
RecountFu:RegisterDB("RecountFuDB"); 

--Added by physical
RecountFu:RegisterDefaults("profile", {
    text = {
        dps_type = "Last Fight",
        show_dps = false,
        update_time = 0.5
    }
})
-- End Add

function RecountFu:OnTextUpdate()
  -- ORIGINAL --
  --    if (self:IsTextShown()) then 
  --       self:ShowText(); 
  --       self:SetText("|cffffffff"..L["labelName"].."|r");
  --     else 
  --       self:HideText(); 
  --    end 
  -- end 
  -- END ORIGINAL --
  self:DoTextUpdate()
end

function RecountFu:OnTooltipUpdate() 
   --added by physical
   cat = Tablet:AddCategory(
		'columns', 2,
        'text',"DPS"
	)
    local line1 = {}
    local line2 = {}
    line1['text'] = "Overall"
    line1['text2'] = getDPS("OverallData")
    line1['textR2'] = 1
	line1['textG2'] = 0
	line1['textB2'] = 0
    
    line2['text'] = "Last Fight"
    line2['text2'] = getDPS("Fight1")
    line2['textR2'] = 1
	line2['textG2'] = 0
	line2['textB2'] = 0
    
    cat:AddLine(line1)
    cat:AddLine(line2)
    --end add
   Tablet:SetHint(L["tabletHint1"] .. "\n" .. L["tabletHint2"].. "\n" .. L["tabletHint3"]);
end 

function RecountFu:OnClick()
		if (IsAltKeyDown()) then
			Recount:ResetData();
			return
		end		
 
    if (Recount.MainWindow:IsShown()) then 
        Recount.MainWindow:Hide() 
    else 
        Recount.MainWindow:Show() 
    end    
end 

function RecountFu:OnDoubleClick()
    Recount:ResetPositions(); 
    Recount.MainWindow:Show(); 
end


--Added by physical
function RecountFu:OnEnable()
    self:UpdateTimeChanged()
    self.LastFightDPS =0
    self.CurrentFightDPS=0
end

function RecountFu:UpdateTimeChanged()
    if(self:IsEventRegistered(self.name.."TEXT_UPDATE")) then
        self:UnregisterEvent(self.name.."TEXT_UPDATE")
    end
    if(RecountFu.db.profile.text.show_dps) then
        self:ScheduleRepeatingEvent(self.name.."TEXT_UPDATE",RecountFu.DoTextUpdate,RecountFu.db.profile.text.update_time,self)
    end
end

function RecountFu:DoTextUpdate()
    local text = ""
    if(self:IsTextShown()) then
        if(RecountFu.db.profile.text.show_dps) then
            text = text.."|cff00ffffDPS|r:"
            local dps = "Not Set"
            if(RecountFu.db.profile.text.dps_type == "LastFight") then
                if(Recount.InCombat) then
                    self.CurrentFightDPS = getDPS("CurrentFightData")
                    text = text .."|cffff0000"..self.CurrentFightDPS.."|r"
                else
                    self.LastFightDPS = getDPS("Fight1")
                    if(self.LastFightDPS == 0) then
                        if(self.CurrentFightDPS > 0) then
                            text = text .."|cffffff00"..self.CurrentFightDPS.."|r"
                        else
                            text = text .."|cff00ff00-|r"
                        end
                    else
                        text = text .."|cffffffff"..self.LastFightDPS.."|r"
                    end
                end              
            elseif(RecountFu.db.profile.text.dps_type == "Overall") then
                text = text .."|cffff00ff"..getDPS("OverallData").."|r"
            end
            self:SetText(text)
        else
            self:SetText("|cffffffff"..L["labelName"].."|r");
        end
    end
end

function getDPS(tableToUse)
    playerName = UnitName("player")
    Epsilon=0.000000000000000001
    combatData = Recount.db.char.combatants[playerName].Fights[tableToUse]
    return math.floor(10*combatData.Damage/(combatData.ActiveTime+Epsilon)+0.5)/10
end
--End Add